function runEval(EXIDX)

	[dataDir,~] = setupPaths() ;
	datasetDir  = fullfile(dataDir,'flowwebDataset') ;

	delete(gcp('nocreate')) ;

	setenv('OMP_NUM_THREADS', '1') ;

	% class specific filters eval
	resultDir  =  fullfile(dataDir,'eval','001-classSpecificFilters-DSP');
	ex(1).opts = ...
		{ 'resultDir', resultDir, ...
		  'datasetRootDir', datasetDir, ...
		  'netPath',  fullfile(dataDir,'001-classSpecificFilters-%s/net-epoch-1.mat'), ...
		  'netName', 'keypoints', ...
	      'normKeypoints', true, ...
	      'fullyConv', true, ...
	      'flowsFunc', @(opts,ims,imgset) dspFlows(opts,ims,imgset); 
	      } ;

	% class agnostic filter eval
	resultDir = fullfile(dataDir,'eval','001-classAgnosticFilters');
	ex(2).opts = ...
		{ 'resultDir', resultDir, ...
		  'datasetRootDir', datasetDir, ...
		  'netPath',  fullfile(dataDir,'001-classAgnosticFilters/net-epoch-6.mat'), ...
		  'netName', 'ae256', ...
	      'normKeypoints', true, ...
	      'fullyConv', true, ...
	      'flowsFunc', @(opts,ims,imgset) dspFlows(opts,ims,imgset); 
	      } ;

	% baseline HoG
	resultDir  =  fullfile(dataDir,'eval','001-hog-DSP');
	ex(3).opts = ...
		{ 'resultDir',  resultDir, ...
		  'datasetRootDir', datasetDir, ...
		  'netPath',    '', ...
	      'netName',    'hog', ...
	      'flowsFunc',  @(opts,ims,imgset) dspFlows(opts,ims,imgset), ...
	      } ;

	for exi = EXIDX

		fprintf('evaluating exp %s\n',findArg(ex(exi).opts,'resultDir'));

		evalFlowWebDataset(ex(exi).opts{:});

		delete(gcp('nocreate'));

	end

end

function arg = findArg(exopts,argName)
	idpos = find(strcmp(exopts,argName),1,'last') ;
	arg = exopts{idpos+1};
end