function experiments_stage1(EXIs,GPU)

[dataDir,imagenetDir] = setupPaths();

ex    = struct();  
exidx = 1;

classes = { 'car','bicycle','aeroplane', 'bird', 'boat', 'bottle', 'bus', ...
		    'cat', 'chair', 'cow', 'dining table', 'dog', 'horse', ...
		    'motorbike',  'potted plant', 'sheep', 'sofa', 'train', 'tvmonitor','person' } ;
classes = sort(classes);
disp(classes);

for clsi = 1:numel(classes)

	cls_  = classes{clsi};
	cls__ = strrep(cls_,' ','_');
	resultDir = fullfile(dataDir,sprintf('001-classSpecificFilters-%s',cls__));
	ex(exidx).opts = { ...
	   				   'resultDir', resultDir, ...
	   				   'imdbPath', fullfile(dataDir,'imdb.mat'), ...
					   'imageDir', imagenetDir, ...
				   	   'net', {...
								'sourceModelPath', fullfile(dataDir,'imagenet-resnet-50-dag.mat'), ... 
								'covFile', fullfile(dataDir,'imagenet-resnet-50-dag.mat.covest.mat'), ...
								'upNorm', true, ...
								'imSize', 224, ...  
								'outSize', [224 224]/4, ... 
								'whitenNorm', true, ...
								'whtStrength', 1e5, ...
								'nKeypoints', 200, ...
								'appFeats', {'res2cx','res4cx','res5cx'}, ...
								'fSize',3, ...
								'kpAct', 'softplus', ...
								'hcValve', 0, ...
								'maxAppDim', 256, ...    
								'DO_diversity', 1e4, ...
					  		   	'DO_objective', 1, ...
								'DO_auxNeg', 10, ...
								'auxNegAfterBorder', false, ...
					  		   }, ... 
					   'train', { ...
					   			'learningRate', repmat(1e-2,1,1), ...
					  			'continue', true, ...
					  			'saveProgress', true, ...
					  			'batchSize', 16, ... 
					  			'debugShow', 50, ... 
					   			'numSubBatches', 2}, ... 
						'nPos',       2e4, ...
						'nNeg',       2e4, ...   
						'nPosVal',    64, ... 
						'nNegVal',    5, ... 
						'flip',       true, ... 
						'randSample', true, ...
						'obClasses',  classes(clsi), ...
						};
	exidx = exidx+1;

end

for exi = 1:numel(ex)
	resdir = findArg( ex(exi).opts, 'resultDir' );
	if ismember(exi,EXIs)
		fprintf('%d - %s <------\n', exi, resdir );
	else
		fprintf('%d - %s\n', exi, resdir );
	end
end

for exi = EXIs
	trainAnchorNet(ex(exi).opts{:},'GPU',GPU );
end

end

function arg = findArg(exopts,argName)
	idpos = find(strcmp(exopts,argName),1,'last') ;
	arg = exopts{idpos+1};
end

