function experiments_stage2(EXIs,GPU)

[dataDir,imagenetDir] = setupPaths();

ex    = struct();
exidx = 1;

classes = { 'car','bicycle','aeroplane', 'bird', 'boat', ...
			'bottle', 'bus', 'cat', 'chair', 'cow', 'dining table', ...
			'dog', 'horse', 'motorbike',  'potted plant', 'sheep', ...
			'sofa', 'train', 'tvmonitor','person' }; 
classes = sort(classes);

initDirs = {};
for clsi = 1:numel(classes)
	cls_ = classes{clsi};
	cls__ = strrep(cls_,' ','_');
	initFl = fullfile( dataDir, sprintf('001-classSpecificFilters-%s/net-epoch-1.mat',cls__) ) ;
	initDirs{end+1} = initFl;
end
resultDir = fullfile( dataDir, '001-classAgnosticFilters' ) ;

netOpts = {... 
			'sourceModelPath',fullfile(dataDir,'imagenet-resnet-50-dag.mat'), ...
			'covFile',fullfile(dataDir,'imagenet-resnet-50-dag.mat.covest.mat'), ...
			'upNorm', true, ...
			'imSize', 224, ...  
			'outSize', [224 224]/4, ... 
			'whitenNorm', true, ...
			'whtStrength', 1e5, ...
			'nKeypoints', 200, ...
			'appFeats', {'res2cx','res4cx','res5cx'}, ...
			'fSize',3, ...
			'kpAct', 'softplus', ...
			'hcValve', 1, ...
			'maxAppDim', 256, ...   
			'DO_diversity', 1e4, ...% 1e4, ...
			'DO_objective', 1, ...
			'DO_auxNeg', 10/20, ...
			'DO_sharing', 1e6, ...
			'auxNegAfterBorder', false, ...
			'hcValve', 1, ...
			...
			'killKPLR',1e-4, ...
			'fullBPLR', 1e-4, ...
			'sharing', 256, ...  
			'sharingValve', 1, ...
			'sharingGlobNorm', true, ...
			'sharingDrop', 0.25, ...
			'sharingFSize', 1, ... 
			'sharingOrth', 1e5 , ...
			'initKPWith', initDirs, ... 
			...
		   };

ex(exidx).opts = { ...
   				   'resultDir', resultDir, ... 
   				   'imdbPath', '~/imdb/imdbILSVRC12ToPascalBox.mat', ...
				   'imageDir', '/datasets/imagenet12/ILSVRC2012/images', ... 
			   	   'net', netOpts, ...
				   'train', {...
				   			'learningRate', repmat(1e-2,1,6), ... 
				  			'continue', true, ... 
				  			'saveProgress', true, ...
				  			'batchSize', 16, ... 
				  			'debugShow', 10, ...      
				   			'numSubBatches', 4}, ... 
					'nPos', 1e3, ... 
					'nNeg', 1e3, ...   
					'nPosVal', 10, ...
					'nNegVal', 0, ... 
					'obClasses',  classes, ...
					};
exidx = exidx+1; 



for exi=1:numel(ex)
	resdir = findArg( ex(exi).opts, 'resultDir' );
	if ismember(exi,EXIs)
		fprintf('%d - %s <------\n', exi, resdir );
	else
		fprintf('%d - %s\n', exi, resdir );
	end
end

for exi = EXIs
	trainAnchorNet(ex(exi).opts{:},'GPU',GPU );
end

end

function arg = findArg(exopts,argName)
	idpos = find(strcmp(exopts,argName),1,'last') ;
	arg = exopts{idpos+1};
end